package com.unipi.talepis.producerconsumer2;

import java.util.Random;

public class Consumer implements Runnable {
    Random r = new Random();
    private final ProductLine productLine;

    public Consumer(ProductLine productLine) {
        this.productLine = productLine;
    }

    public void run() {
        for(String receivedProduct = productLine.receive();
            !receivedProduct.contains("End");
            receivedProduct = productLine.receive()) {
            //System.out.println(receivedProduct+" being consumed");
            try {
                Thread.sleep(r.nextInt(1000, 5000));
            } catch (InterruptedException e) {
                Thread.currentThread().interrupt();
                System.err.println("Thread interrupted from sleep");
            }
        }
        System.out.println("Bye bye from "+Thread.currentThread().getName());
    }
}
