package com.unipi.talepis.producerconsumer2;

public class ProductLine {
    private String product;
    // True if receiver should wait
    // False if sender should wait
    private boolean waitForTransfering = true;
    public synchronized String receive() {
        while (waitForTransfering) {
            try {
                wait();
            } catch (InterruptedException e) {
                System.err.println("Thread work cancelled");
                return Thread.currentThread().getName()+" work has been cancelled";
            }
        }
        waitForTransfering = true;
        String returnedProduct;
        if ("End".equals(product))
            returnedProduct= product;
        else returnedProduct = "Processed "+product;
        notifyAll();
        System.out.println(Thread.currentThread().getName()+" consumed "+product);
        return returnedProduct;
    }
    public synchronized void send(String product) {
        while (!waitForTransfering) {
            try {
                wait();
            } catch (InterruptedException e) {
                System.err.println("Thread work cancelled");
                return;
            }
        }
        waitForTransfering = false;
        this.product = product;
        System.out.println("Produced "+product);
        notifyAll();
    }
}
